var fs = require('fs');
var parse = require('csv-parse');


function readCSV() {
    let entries = [];
    let count = 0;

    fs.createReadStream('shakespeare_plays_sample.csv')
        .pipe(parse({ delimiter: ';', from_line: 2 }))
        .on('data', function (row) {
            count++;
            entries.push(new Entry(row[0], row[1], row[2], row[3], row[4], row[5]))

            if (count % 100 == 0) {
                processEntries(entries);
                count = 0;
                entries = []; // clear the array
            }
        })
        .on('end', function () {
            processEntries(entries);
        });
}

function processEntries(entries) {
    console.log("Processing " + entries[0].Id + "  to " + entries[entries.length - 1].Id);
}

class Entry {
    constructor(id, play, characterLineNumber, actSceneLine, character, line) {
        this.Id = id;
        this.Play = play;
        this.CharacterLineNumber = characterLineNumber;
        this.ActSceneLine = actSceneLine;
        this.Character = character;
        this.Line = line;
    }
}

readCSV();